Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/yahoo.c	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -2,5 +2,5 @@
  * libyahoo2 wrapper to BitlBee
  *
- * Mostly Copyright 2004 Wilmer van der Gaast <wilmer@gaast.net>
+ * Mostly Copyright 2004-2010 Wilmer van der Gaast <wilmer@gaast.net>
  *
  * This program is free software; you can redistribute it and/or modify
@@ -339,14 +339,18 @@
 static void byahoo_auth_allow( struct im_connection *ic, const char *who )
 {
+	/*
 	struct byahoo_data *yd = (struct byahoo_data *) ic->proto_data;
 	
 	yahoo_accept_buddy_ymsg13( yd->y2_id, NULL, who );
+	*/
 }
 
 static void byahoo_auth_deny( struct im_connection *ic, const char *who )
 {
+	/*
 	struct byahoo_data *yd = (struct byahoo_data *) ic->proto_data;
 	
 	yahoo_reject_buddy_ymsg13( yd->y2_id, NULL, who, NULL );
+	*/
 }
 
@@ -421,5 +425,5 @@
 	}
 	
-	d->callback( d->fd, 0, d->data );
+	d->callback( NULL + d->fd, 0, d->data );
 	g_free( d );
 }
@@ -441,5 +445,5 @@
 		return FALSE;
 	
-	yahoo_read_ready( d->id, d->fd, d->data );
+	yahoo_read_ready( d->id, NULL + d->fd, d->data );
 	
 	return TRUE;
@@ -458,5 +462,5 @@
 	struct byahoo_write_ready_data *d = data;
 	
-	return yahoo_write_ready( d->id, d->fd, d->data );
+	return yahoo_write_ready( d->id, NULL + d->fd, d->data );
 }
 
@@ -606,7 +610,4 @@
 		flags = 0;
 		break;
-	case YAHOO_STATUS_NOTIFY:
-		state_string = "Notify";
-		break;
 	}
 	
@@ -615,4 +616,8 @@
 	if( stat == YAHOO_STATUS_IDLE )
 		imcb_buddy_times( ic, who, 0, idle );
+}
+
+void ext_yahoo_got_buzz( int id, const char *me, const char *who, long tm )
+{
 }
 
@@ -630,11 +635,18 @@
 }
 
-void ext_yahoo_got_file( int id,
-                         const char *ignored,
-                         const char *who, const char *url, long expires, const char *msg, const char *fname, unsigned long fesize )
+void ext_yahoo_got_file( int id, const char *ignored, const char *who, const char *msg,
+                         const char *fname, unsigned long fesize, char *trid )
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
 	
 	imcb_log( ic, "Got a file transfer (file = %s) from %s. Ignoring for now due to lack of support.", fname, who );
+}
+
+void ext_yahoo_got_ft_data( int id, const unsigned char *in, int len, void *data )
+{
+}
+
+void ext_yahoo_file_transfer_done( int id, int result, void *data )
+{
 }
 
@@ -649,5 +661,5 @@
 }
 
-void ext_yahoo_system_message( int id, const char *msg )
+void ext_yahoo_system_message( int id, const char *me, const char *who, const char *msg )
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
@@ -671,7 +683,8 @@
 
 /* TODO: Clear up the mess of inp and d structures */
-int ext_yahoo_add_handler( int id, int fd, yahoo_input_condition cond, void *data )
+int ext_yahoo_add_handler( int id, void *fd_, yahoo_input_condition cond, void *data )
 {
 	struct byahoo_input_data *inp = g_new0( struct byahoo_input_data, 1 );
+	int fd = (int) fd_;
 	
 	if( cond == YAHOO_INPUT_READ )
@@ -700,10 +713,10 @@
 	{
 		g_free( inp );
-		return( -1 );
+		return -1;
 		/* Panic... */
 	}
 	
 	byahoo_inputs = g_slist_append( byahoo_inputs, inp );
-	return( inp->h );
+	return inp->h;
 }
 
@@ -729,5 +742,5 @@
 }
 
-int ext_yahoo_connect_async( int id, const char *host, int port, yahoo_connect_callback callback, void *data )
+int ext_yahoo_connect_async( int id, const char *host, int port, yahoo_connect_callback callback, void *data, int use_ssl )
 {
 	struct byahoo_connect_callback_data *d;
@@ -745,6 +758,31 @@
 	d->id = id;
 	
-	return( fd );
-}
+	return fd;
+}
+
+char *ext_yahoo_get_ip_addr( const char *domain )
+{
+	return NULL;
+}
+
+int ext_yahoo_write( void *fd, char *buf, int len )
+{
+	return write( (int) fd, buf, len );
+}
+
+int ext_yahoo_read( void *fd, char *buf, int len )
+{
+	return read( (int) fd, buf, len );
+}
+
+void ext_yahoo_close( void *fd )
+{
+	close( (int) fd );
+}
+
+void ext_yahoo_got_buddy_change_group( int id, const char *me, const char *who,
+                                       const char *old_group, const char *new_group )
+{
+}                                
 
 /* Because we don't want asynchronous connects in BitlBee, and because
@@ -752,39 +790,4 @@
 int ext_yahoo_connect(const char *host, int port)
 {
-#if 0
-	struct sockaddr_in serv_addr;
-	static struct hostent *server;
-	static char last_host[256];
-	int servfd;
-	char **p;
-
-	if(last_host[0] || g_strcasecmp(last_host, host)!=0) {
-		if(!(server = gethostbyname(host))) {
-			return -1;
-		}
-		strncpy(last_host, host, 255);
-	}
-
-	if((servfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
-		return -1;
-	}
-
-	for (p = server->h_addr_list; *p; p++)
-	{
-		memset(&serv_addr, 0, sizeof(serv_addr));
-		serv_addr.sin_family = AF_INET;
-		memcpy(&serv_addr.sin_addr.s_addr, *p, server->h_length);
-		serv_addr.sin_port = htons(port);
-
-		if(connect(servfd, (struct sockaddr *) &serv_addr, 
-					sizeof(serv_addr)) == -1) {
-			return -1;
-		} else {
-			return servfd;
-		}
-	}
-
-	closesocket(servfd);
-#endif
 	return -1;
 }
@@ -898,5 +901,5 @@
 }
 
-void ext_yahoo_chat_join( int id, const char *who, const char *room, const char *topic, YList *members, int fd )
+void ext_yahoo_chat_join( int id, const char *who, const char *room, const char *topic, YList *members, void *fd )
 {
 }
@@ -928,7 +931,5 @@
 void ext_yahoo_contact_auth_request( int id, const char *myid, const char *who, const char *msg )
 {
-	struct im_connection *ic = byahoo_get_ic_by_id( id );
-	
-	imcb_ask_auth( ic, who, NULL );
+	/* Apparently no longer implemented.. */
 }
 
@@ -944,5 +945,5 @@
 }
 
-void ext_yahoo_game_notify( int id, const char *me, const char *who, int stat )
+void ext_yahoo_game_notify( int id, const char *me, const char *who, int stat, const char *msg )
 {
 }
Index: protocols/yahoo/yahoo2.h
===================================================================
--- protocols/yahoo/yahoo2.h	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/yahoo2.h	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -51,11 +51,11 @@
 #include "yahoo2_types.h"
 
-/* returns the socket descriptor for a given pager connection. shouldn't be needed */
-int  yahoo_get_fd(int id);
+/* returns the socket descriptor object for a given pager connection. shouldn't be needed */
+	void *yahoo_get_fd(int id);
 
 /* says how much logging to do */
 /* see yahoo2_types.h for the different values */
-int  yahoo_set_log_level(enum yahoo_log_level level);
-enum yahoo_log_level  yahoo_get_log_level( void );
+	int yahoo_set_log_level(enum yahoo_log_level level);
+	enum yahoo_log_level yahoo_get_log_level(void);
 
 /* these functions should be self explanatory */
@@ -222,6 +222,6 @@
 /* registered by ext_yahoo_add_handler */
 /* if these return negative values, errno may be set */
-int  yahoo_read_ready(int id, int fd, void *data);
-int  yahoo_write_ready(int id, int fd, void *data);
+	int yahoo_read_ready(int id, void *fd, void *data);
+	int yahoo_write_ready(int id, void *fd, void *data);
 
 /* utility functions. these do not hit the server */
@@ -240,7 +240,4 @@
 	void yahoo_buddyicon_request(int id, const char *who);
 
-	void yahoo_accept_buddy_ymsg13(int,const char*, const char*);
-	void yahoo_reject_buddy_ymsg13(int,const char*, const char*, const char*);
-
 #include "yahoo_httplib.h"
 
Index: protocols/yahoo/yahoo2_callbacks.h
===================================================================
--- protocols/yahoo/yahoo2_callbacks.h	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/yahoo2_callbacks.h	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -55,5 +55,6 @@
  * 
  * Params:
- *     fd    - The file descriptor that has been connected, or -1 on error
+ *     fd    - The file descriptor object that has been connected, or NULL on 
+ *             error
  *     error - The value of errno set by the call to connect or 0 if no error
  *	       Set both fd and error to 0 if the connect was cancelled by the
@@ -62,6 +63,6 @@
  *	       function
  */
-typedef void (*yahoo_connect_callback)(int fd, int error, void *callback_data);
-
+	typedef void (*yahoo_connect_callback) (void *fd, int error,
+		void *callback_data);
 
 /*
@@ -262,8 +263,8 @@
  *	members - the initial members of the chatroom (null terminated YList 
  *	          of yahoo_chat_member's) Must be freed by the client
- *	fd	- the socket where the connection is coming from (for tracking)
+ *	fd	- the object where the connection is coming from (for tracking)
  */
 	void YAHOO_CALLBACK_TYPE(ext_yahoo_chat_join) (int id, const char *me,
-		const char *room, const char *topic, YList *members, int fd);
+		const char *room, const char *topic, YList *members, void *fd);
 
 /*
@@ -364,24 +365,40 @@
  * 	me   - the identity the file was sent to
  * 	who  - the user who sent the file
- * 	url  - the file url
- * 	expires  - the expiry date of the file on the server (timestamp)
  * 	msg  - the message
  * 	fname- the file name if direct transfer
  * 	fsize- the file size if direct transfer
- */
-void YAHOO_CALLBACK_TYPE(ext_yahoo_got_file)(int id, const char *me, const char *who, const char *url, long expires, const char *msg, const char *fname, unsigned long fesize);
-
-
-/*
- * Name: ext_yahoo_contact_auth_request
- * 	Called when a contact wants to add you to his/her contact list
- * Params:
- * 	id   - the id that identifies the server connection
- * 	myid - the identity s/he added
- * 	who  - who did it
- * 	msg  - any message sent
- */
-void YAHOO_CALLBACK_TYPE(ext_yahoo_contact_auth_request)(int id, const char *myid, const char *who, const char *msg);
-
+ * 	trid - transfer id. Unique for this transfer
+ *
+ * NOTE: Subsequent callbacks for file transfer do not send all of this
+ * information again since it is wasteful. Implementations are expected to
+ * save this information and supply it as callback data when the file or
+ * confirmation is sent
+ */
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_got_file) (int id, const char *me,
+		const char *who, const char *msg, const char *fname,
+		unsigned long fesize, char *trid);
+
+/*
+ * Name: ext_yahoo_got_ft_data
+ * 	Called multiple times when parts of the file are received
+ * Params:
+ * 	id   - the id that identifies the server connection
+ * 	in   - The data
+ * 	len  - Length of the data
+ * 	data - callback data
+ */
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_got_ft_data) (int id,
+		const unsigned char *in, int len, void *data);
+
+/*
+ * Name: ext_yahoo_file_transfer_done
+ * 	File transfer is done
+ * Params:
+ * 	id     - the id that identifies the server connection
+ * 	result - To notify if it finished successfully or with a failure
+ * 	data   - callback data
+ */
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_file_transfer_done) (int id,
+		int result, void *data);
 
 /*
@@ -428,7 +445,8 @@
  * 	who  - the handle of the remote user
  * 	stat - 1 if game, 0 if stopped gaming
- */
-void YAHOO_CALLBACK_TYPE(ext_yahoo_game_notify)(int id, const char *me, const char *who, int stat);
-
+ * 	msg  - game description and/or other text
+ */
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_game_notify) (int id, const char *me,
+		const char *who, int stat, const char *msg);
 
 /*
@@ -449,7 +467,10 @@
  * Params:
  * 	id   - the id that identifies the server connection
+ * 	me   - the handle of the identity the notification is sent to
+ * 	who  - the source of the system message (there are different types)
  * 	msg  - the message
  */
-void YAHOO_CALLBACK_TYPE(ext_yahoo_system_message)(int id, const char *msg);
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_system_message) (int id,
+		const char *me, const char *who, const char *msg);
 
 /*
@@ -630,5 +651,5 @@
  * Params:
  * 	id   - the id that identifies the server connection
- * 	fd   - the fd on which to listen
+ * 	fd   - the fd object on which to listen
  * 	cond - the condition on which to call the callback
  * 	data - callback data to pass to yahoo_*_ready
@@ -636,5 +657,5 @@
  * Returns: a tag to be used when removing the handler
  */
-	int YAHOO_CALLBACK_TYPE(ext_yahoo_add_handler) (int id, int fd,
+	int YAHOO_CALLBACK_TYPE(ext_yahoo_add_handler) (int id, void *fd,
 		yahoo_input_condition cond, void *data);
 
@@ -674,10 +695,72 @@
  * 	callback - function to call when connect completes
  * 	callback_data - data to pass to the callback function
- * Returns:
- * 	a unix file descriptor to the socket
+ * 	use_ssl - Whether we need an SSL connection
+ * Returns:
+ * 	a tag signifying the connection attempt
  */
 	int YAHOO_CALLBACK_TYPE(ext_yahoo_connect_async) (int id,
 		const char *host, int port, yahoo_connect_callback callback,
-		void *callback_data);
+		void *callback_data, int use_ssl);
+
+/*
+ * Name: ext_yahoo_get_ip_addr
+ * 	get IP Address for a domain name
+ * Params:
+ * 	domain - Domain name
+ * Returns:
+ * 	Newly allocated string containing the IP Address in IPv4 notation
+ */
+	char *YAHOO_CALLBACK_TYPE(ext_yahoo_get_ip_addr) (const char *domain);
+
+/*
+ * Name: ext_yahoo_write
+ * 	Write data from the buffer into the socket for the specified connection
+ * Params:
+ * 	fd  - the file descriptor object that identifies this connection
+ * 	buf - Buffer to write the data from
+ * 	len - Length of the data
+ * Returns:
+ * 	Number of bytes written or -1 for error
+ */
+	int YAHOO_CALLBACK_TYPE(ext_yahoo_write) (void *fd, char *buf, int len);
+
+/*
+ * Name: ext_yahoo_read
+ * 	Read data into a buffer from socket for the specified connection
+ * Params:
+ * 	fd  - the file descriptor object that identifies this connection
+ * 	buf - Buffer to read the data into
+ * 	len - Max length to read
+ * Returns:
+ * 	Number of bytes read or -1 for error
+ */
+	int YAHOO_CALLBACK_TYPE(ext_yahoo_read) (void *fd, char *buf, int len);
+
+/*
+ * Name: ext_yahoo_close
+ * 	Close the file descriptor object and free its resources. Libyahoo2 will not
+ * 	use this object again.
+ * Params:
+ * 	fd  - the file descriptor object that identifies this connection
+ * Returns:
+ * 	Nothing
+ */
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_close) (void *fd);
+
+/*
+ * Name: ext_yahoo_got_buddy_change_group
+ * 	Acknowledgement of buddy changing group
+ * Params:
+ * 	id: client id
+ * 	me: The user
+ * 	who: Buddy name
+ * 	old_group: Old group name
+ * 	new_group: New group name
+ * Returns:
+ * 	Nothing
+ */
+	void YAHOO_CALLBACK_TYPE(ext_yahoo_got_buddy_change_group) (int id,
+		const char *me, const char *who, const char *old_group,
+		const char *new_group);
 
 #ifdef USE_STRUCT_CALLBACKS
@@ -699,3 +782,2 @@
 
 #endif
-
Index: protocols/yahoo/yahoo2_types.h
===================================================================
--- protocols/yahoo/yahoo2_types.h	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/yahoo2_types.h	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -29,72 +29,173 @@
 #endif
 
-enum yahoo_status {
-	YAHOO_STATUS_DISCONNECTED = -1,
-	YAHOO_STATUS_AVAILABLE = 0,
-	YAHOO_STATUS_BRB,
-	YAHOO_STATUS_BUSY,
-	YAHOO_STATUS_NOTATHOME,
-	YAHOO_STATUS_NOTATDESK,
-	YAHOO_STATUS_NOTINOFFICE,
-	YAHOO_STATUS_ONPHONE,
-	YAHOO_STATUS_ONVACATION,
-	YAHOO_STATUS_OUTTOLUNCH,
-	YAHOO_STATUS_STEPPEDOUT,
-	YAHOO_STATUS_INVISIBLE = 12,
-	YAHOO_STATUS_CUSTOM = 99,
-	YAHOO_STATUS_IDLE = 999,
-	YAHOO_STATUS_WEBLOGIN = 0x5a55aa55,
-	YAHOO_STATUS_OFFLINE = 0x5a55aa56, /* don't ask */
-	YAHOO_STATUS_NOTIFY = 0x16 /* TYPING */
-};
-#define YAHOO_STATUS_GAME	0x2 		/* Games don't fit into the regular status model */
-
-enum yahoo_login_status {
-	YAHOO_LOGIN_OK = 0,
-	YAHOO_LOGIN_LOGOFF = 2,
-	YAHOO_LOGIN_UNAME = 3,
-	YAHOO_LOGIN_PASSWD = 13,
-	YAHOO_LOGIN_LOCK = 14,
-	YAHOO_LOGIN_DUPL = 99,
-	YAHOO_LOGIN_SOCK = -1,
-};
-
-enum ypacket_status {
-	YPACKET_STATUS_DISCONNECTED = -1,
-	YPACKET_STATUS_DEFAULT = 0,
-	YPACKET_STATUS_SERVERACK = 1,
-	YPACKET_STATUS_GAME     = 0x2,
-	YPACKET_STATUS_AWAY     = 0x4,
-	YPACKET_STATUS_CONTINUED = 0x5,
-	YPACKET_STATUS_INVISIBLE = 12,
-	YPACKET_STATUS_NOTIFY = 0x16, /* TYPING */
-	YPACKET_STATUS_WEBLOGIN = 0x5a55aa55,
-	YPACKET_STATUS_OFFLINE = 0x5a55aa56
-};
-
-enum yahoo_error {
-	E_UNKNOWN = -1,
-	E_CONNECTION = -2,
-	E_SYSTEM = -3,
-	E_CUSTOM = 0,
-
-	/* responses from ignore buddy */
-	E_IGNOREDUP = 2,
-	E_IGNORENONE = 3,
-	E_IGNORECONF = 12,
-	
-	/* conference */
-	E_CONFNOTAVAIL = 20
-};
-
-enum yahoo_log_level {
-	YAHOO_LOG_NONE = 0,
-	YAHOO_LOG_FATAL,
-	YAHOO_LOG_ERR,
-	YAHOO_LOG_WARNING,
-	YAHOO_LOG_NOTICE,
-	YAHOO_LOG_INFO,
-	YAHOO_LOG_DEBUG
-};
+	enum yahoo_service {	/* these are easier to see in hex */
+		YAHOO_SERVICE_LOGON = 1,
+		YAHOO_SERVICE_LOGOFF,
+		YAHOO_SERVICE_ISAWAY,
+		YAHOO_SERVICE_ISBACK,
+		YAHOO_SERVICE_IDLE,	/* 5 (placemarker) */
+		YAHOO_SERVICE_MESSAGE,
+		YAHOO_SERVICE_IDACT,
+		YAHOO_SERVICE_IDDEACT,
+		YAHOO_SERVICE_MAILSTAT,
+		YAHOO_SERVICE_USERSTAT,	/* 0xa */
+		YAHOO_SERVICE_NEWMAIL,
+		YAHOO_SERVICE_CHATINVITE,
+		YAHOO_SERVICE_CALENDAR,
+		YAHOO_SERVICE_NEWPERSONALMAIL,
+		YAHOO_SERVICE_NEWCONTACT,
+		YAHOO_SERVICE_ADDIDENT,	/* 0x10 */
+		YAHOO_SERVICE_ADDIGNORE,
+		YAHOO_SERVICE_PING,
+		YAHOO_SERVICE_GOTGROUPRENAME,	/* < 1, 36(old), 37(new) */
+		YAHOO_SERVICE_SYSMESSAGE = 0x14,
+		YAHOO_SERVICE_SKINNAME = 0x15,
+		YAHOO_SERVICE_PASSTHROUGH2 = 0x16,
+		YAHOO_SERVICE_CONFINVITE = 0x18,
+		YAHOO_SERVICE_CONFLOGON,
+		YAHOO_SERVICE_CONFDECLINE,
+		YAHOO_SERVICE_CONFLOGOFF,
+		YAHOO_SERVICE_CONFADDINVITE,
+		YAHOO_SERVICE_CONFMSG,
+		YAHOO_SERVICE_CHATLOGON,
+		YAHOO_SERVICE_CHATLOGOFF,
+		YAHOO_SERVICE_CHATMSG = 0x20,
+		YAHOO_SERVICE_GAMELOGON = 0x28,
+		YAHOO_SERVICE_GAMELOGOFF,
+		YAHOO_SERVICE_GAMEMSG = 0x2a,
+		YAHOO_SERVICE_FILETRANSFER = 0x46,
+		YAHOO_SERVICE_VOICECHAT = 0x4A,
+		YAHOO_SERVICE_NOTIFY,
+		YAHOO_SERVICE_VERIFY,
+		YAHOO_SERVICE_P2PFILEXFER,
+		YAHOO_SERVICE_PEERTOPEER = 0x4F,	/* Checks if P2P possible */
+		YAHOO_SERVICE_WEBCAM,
+		YAHOO_SERVICE_AUTHRESP = 0x54,
+		YAHOO_SERVICE_LIST,
+		YAHOO_SERVICE_AUTH = 0x57,
+		YAHOO_SERVICE_AUTHBUDDY = 0x6d,
+		YAHOO_SERVICE_ADDBUDDY = 0x83,
+		YAHOO_SERVICE_REMBUDDY,
+		YAHOO_SERVICE_IGNORECONTACT,	/* > 1, 7, 13 < 1, 66, 13, 0 */
+		YAHOO_SERVICE_REJECTCONTACT,
+		YAHOO_SERVICE_GROUPRENAME = 0x89,	/* > 1, 65(new), 66(0), 67(old) */
+		YAHOO_SERVICE_Y7_PING = 0x8A,
+		YAHOO_SERVICE_CHATONLINE = 0x96,	/* > 109(id), 1, 6(abcde) < 0,1 */
+		YAHOO_SERVICE_CHATGOTO,
+		YAHOO_SERVICE_CHATJOIN,	/* > 1 104-room 129-1600326591 62-2 */
+		YAHOO_SERVICE_CHATLEAVE,
+		YAHOO_SERVICE_CHATEXIT = 0x9b,
+		YAHOO_SERVICE_CHATADDINVITE = 0x9d,
+		YAHOO_SERVICE_CHATLOGOUT = 0xa0,
+		YAHOO_SERVICE_CHATPING,
+		YAHOO_SERVICE_COMMENT = 0xa8,
+		YAHOO_SERVICE_GAME_INVITE = 0xb7,
+		YAHOO_SERVICE_STEALTH_PERM = 0xb9,
+		YAHOO_SERVICE_STEALTH_SESSION = 0xba,
+		YAHOO_SERVICE_AVATAR = 0xbc,
+		YAHOO_SERVICE_PICTURE_CHECKSUM = 0xbd,
+		YAHOO_SERVICE_PICTURE = 0xbe,
+		YAHOO_SERVICE_PICTURE_UPDATE = 0xc1,
+		YAHOO_SERVICE_PICTURE_UPLOAD = 0xc2,
+		YAHOO_SERVICE_YAB_UPDATE = 0xc4,
+		YAHOO_SERVICE_Y6_VISIBLE_TOGGLE = 0xc5,	/* YMSG13, key 13: 2 = invisible, 1 = visible */
+		YAHOO_SERVICE_Y6_STATUS_UPDATE = 0xc6,	/* YMSG13 */
+		YAHOO_SERVICE_PICTURE_STATUS = 0xc7,	/* YMSG13, key 213: 0 = none, 1 = avatar, 2 = picture */
+		YAHOO_SERVICE_VERIFY_ID_EXISTS = 0xc8,
+		YAHOO_SERVICE_AUDIBLE = 0xd0,
+		YAHOO_SERVICE_Y7_PHOTO_SHARING = 0xd2,
+		YAHOO_SERVICE_Y7_CONTACT_DETAILS = 0xd3,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_CHAT_SESSION = 0xd4,
+		YAHOO_SERVICE_Y7_AUTHORIZATION = 0xd6,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_FILETRANSFER = 0xdc,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_FILETRANSFERINFO,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_FILETRANSFERACCEPT,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_MINGLE = 0xe1,	/* YMSG13 */
+		YAHOO_SERVICE_Y7_CHANGE_GROUP = 0xe7,	/* YMSG13 */
+		YAHOO_SERVICE_MYSTERY = 0xef,	/* Don't know what this is for */
+		YAHOO_SERVICE_Y8_STATUS = 0xf0,	/* YMSG15 */
+		YAHOO_SERVICE_Y8_LIST = 0Xf1,	/* YMSG15 */
+		YAHOO_SERVICE_MESSAGE_CONFIRM = 0xfb,
+		YAHOO_SERVICE_WEBLOGIN = 0x0226,
+		YAHOO_SERVICE_SMS_MSG = 0x02ea
+	};
+
+	enum yahoo_status {
+		YAHOO_STATUS_AVAILABLE = 0,
+		YAHOO_STATUS_BRB,
+		YAHOO_STATUS_BUSY,
+		YAHOO_STATUS_NOTATHOME,
+		YAHOO_STATUS_NOTATDESK,
+		YAHOO_STATUS_NOTINOFFICE,
+		YAHOO_STATUS_ONPHONE,
+		YAHOO_STATUS_ONVACATION,
+		YAHOO_STATUS_OUTTOLUNCH,
+		YAHOO_STATUS_STEPPEDOUT,
+		YAHOO_STATUS_INVISIBLE = 12,
+		YAHOO_STATUS_CUSTOM = 99,
+		YAHOO_STATUS_IDLE = 999,
+		YAHOO_STATUS_OFFLINE = 0x5a55aa56	/* don't ask */
+	};
+
+	enum ypacket_status {
+		YPACKET_STATUS_DISCONNECTED = -1,
+		YPACKET_STATUS_DEFAULT = 0,
+		YPACKET_STATUS_SERVERACK = 1,
+		YPACKET_STATUS_GAME = 0x2,
+		YPACKET_STATUS_AWAY = 0x4,
+		YPACKET_STATUS_CONTINUED = 0x5,
+		YPACKET_STATUS_INVISIBLE = 12,
+		YPACKET_STATUS_NOTIFY = 0x16,	/* TYPING */
+		YPACKET_STATUS_WEBLOGIN = 0x5a55aa55,
+		YPACKET_STATUS_OFFLINE = 0x5a55aa56
+	};
+
+#define YAHOO_STATUS_GAME	0x2	/* Games don't fit into the regular status model */
+
+	enum yahoo_login_status {
+		YAHOO_LOGIN_OK = 0,
+		YAHOO_LOGIN_LOGOFF = 1,
+		YAHOO_LOGIN_UNAME = 3,
+		YAHOO_LOGIN_PASSWD = 13,
+		YAHOO_LOGIN_LOCK = 14,
+		YAHOO_LOGIN_DUPL = 99,
+		YAHOO_LOGIN_SOCK = -1,
+		YAHOO_LOGIN_UNKNOWN = 999
+	};
+
+	enum yahoo_error {
+		E_UNKNOWN = -1,
+		E_CONNECTION = -2,
+		E_SYSTEM = -3,
+		E_CUSTOM = 0,
+
+		/* responses from ignore buddy */
+		E_IGNOREDUP = 2,
+		E_IGNORENONE = 3,
+		E_IGNORECONF = 12,
+
+		/* conference */
+		E_CONFNOTAVAIL = 20
+	};
+
+	enum yahoo_log_level {
+		YAHOO_LOG_NONE = 0,
+		YAHOO_LOG_FATAL,
+		YAHOO_LOG_ERR,
+		YAHOO_LOG_WARNING,
+		YAHOO_LOG_NOTICE,
+		YAHOO_LOG_INFO,
+		YAHOO_LOG_DEBUG
+	};
+
+	enum yahoo_file_transfer {
+		YAHOO_FILE_TRANSFER_INIT = 1,
+		YAHOO_FILE_TRANSFER_ACCEPT = 3,
+		YAHOO_FILE_TRANSFER_REJECT = 4,
+		YAHOO_FILE_TRANSFER_DONE = 5,
+		YAHOO_FILE_TRANSFER_RELAY,
+		YAHOO_FILE_TRANSFER_FAILED,
+		YAHOO_FILE_TRANSFER_UNKNOWN
+	};
 
 #define YAHOO_PROTO_VER 0x0010
@@ -121,171 +222,175 @@
 #define YAHOO_STYLE_URLOFF "\033[xlm"
 
-enum yahoo_connection_type {
-	YAHOO_CONNECTION_PAGER=0,
-	YAHOO_CONNECTION_FT,
-	YAHOO_CONNECTION_YAB,
-	YAHOO_CONNECTION_WEBCAM_MASTER,
-	YAHOO_CONNECTION_WEBCAM,
-	YAHOO_CONNECTION_CHATCAT,
-	YAHOO_CONNECTION_SEARCH,
-	YAHOO_CONNECTION_AUTH,
-};
-
-enum yahoo_webcam_direction_type {
-        YAHOO_WEBCAM_DOWNLOAD=0,
-        YAHOO_WEBCAM_UPLOAD
-};
-
-enum yahoo_stealth_visibility_type {
-	YAHOO_STEALTH_DEFAULT = 0,
-  	YAHOO_STEALTH_ONLINE,
-  	YAHOO_STEALTH_PERM_OFFLINE
-};
+	enum yahoo_connection_type {
+		YAHOO_CONNECTION_PAGER = 0,
+		YAHOO_CONNECTION_FT,
+		YAHOO_CONNECTION_YAB,
+		YAHOO_CONNECTION_WEBCAM_MASTER,
+		YAHOO_CONNECTION_WEBCAM,
+		YAHOO_CONNECTION_CHATCAT,
+		YAHOO_CONNECTION_SEARCH,
+		YAHOO_CONNECTION_AUTH
+	};
+
+	enum yahoo_webcam_direction_type {
+		YAHOO_WEBCAM_DOWNLOAD = 0,
+		YAHOO_WEBCAM_UPLOAD
+	};
+
+	enum yahoo_stealth_visibility_type {
+		YAHOO_STEALTH_DEFAULT = 0,
+		YAHOO_STEALTH_ONLINE,
+		YAHOO_STEALTH_PERM_OFFLINE
+	};
 
 /* chat member attribs */
 #define YAHOO_CHAT_MALE 0x8000
 #define YAHOO_CHAT_FEMALE 0x10000
+#define YAHOO_CHAT_FEMALE 0x10000
 #define YAHOO_CHAT_DUNNO 0x400
 #define YAHOO_CHAT_WEBCAM 0x10
 
-enum yahoo_webcam_conn_type { Y_WCM_DIALUP, Y_WCM_DSL, Y_WCM_T1 };
-
-struct yahoo_webcam {
-	int direction;     /* Uploading or downloading */
-	int conn_type;     /* 0=Dialup, 1=DSL/Cable, 2=T1/Lan */
-
-	char *user;        /* user we are viewing */
-	char *server;      /* webcam server to connect to */
-	int   port;        /* webcam port to connect on */
-	char *key;         /* key to connect to the server with */
-	char *description; /* webcam description */
-	char *my_ip;       /* own ip number */
-};
-
-struct yahoo_webcam_data {
-	unsigned int data_size;
-	unsigned int to_read;
-	unsigned int timestamp;
-	unsigned char packet_type;
-};
-
-struct yahoo_data {
-	char  *user;
-	char  *password;
-
-	char  *cookie_y;
-	char  *cookie_t;
-	char  *cookie_c;
-	char  *login_cookie;
-
-	YList *buddies;
-	YList *ignore;
-	YList *identities;
-	char  *login_id;
-
-	int   current_status;
-	int   initial_status;
-	int   logged_in;
-
-	int   session_id;
-
-	int   client_id;
-
-	char  *rawbuddylist;
-	char  *ignorelist;
-
-	void  *server_settings;
-	
-	struct yahoo_process_status_entry *half_user;
-};
-
-struct yab {
-	int yid;
-	char *id;
-	char *fname;
-	char *lname;
-	char *nname;
-	char *email;
-	char *hphone;
-	char *wphone;
-	char *mphone;
-	int  dbid;
-};
-
-struct yahoo_buddy {
-	char *group;
-	char *id;
-	char *real_name;
-	struct yab *yab_entry;
-};
-
-enum yahoo_search_type {
-	YAHOO_SEARCH_KEYWORD = 0,
-	YAHOO_SEARCH_YID,
-	YAHOO_SEARCH_NAME
-};
-
-enum yahoo_search_gender {
-	YAHOO_GENDER_NONE = 0,
-	YAHOO_GENDER_MALE,
-	YAHOO_GENDER_FEMALE
-};
-
-enum yahoo_search_agerange {
-	YAHOO_AGERANGE_NONE = 0
-};
-
-struct yahoo_found_contact {
-	char *id;
-	char *gender;
-	char *location;
-	int age;
-	int online;
-};
+	enum yahoo_webcam_conn_type { Y_WCM_DIALUP, Y_WCM_DSL, Y_WCM_T1 };
+
+	struct yahoo_webcam {
+		int direction;	/* Uploading or downloading */
+		int conn_type;	/* 0=Dialup, 1=DSL/Cable, 2=T1/Lan */
+
+		char *user;	/* user we are viewing */
+		char *server;	/* webcam server to connect to */
+		int port;	/* webcam port to connect on */
+		char *key;	/* key to connect to the server with */
+		char *description;	/* webcam description */
+		char *my_ip;	/* own ip number */
+	};
+
+	struct yahoo_webcam_data {
+		unsigned int data_size;
+		unsigned int to_read;
+		unsigned int timestamp;
+		unsigned char packet_type;
+	};
+
+	struct yahoo_data {
+		char *user;
+		char *password;
+
+		char *cookie_y;
+		char *cookie_t;
+		char *cookie_c;
+		char *cookie_b;
+		char *login_cookie;
+		char *crumb;
+		char *seed;
+
+		YList *buddies;
+		YList *ignore;
+		YList *identities;
+		char *login_id;
+
+		int current_status;
+		int initial_status;
+		int logged_in;
+
+		int session_id;
+
+		int client_id;
+
+		char *rawbuddylist;
+		char *ignorelist;
+
+		void *server_settings;
+
+		struct yahoo_process_status_entry *half_user;
+	};
+
+	struct yab {
+		int yid;
+		char *id;
+		char *fname;
+		char *lname;
+		char *nname;
+		char *email;
+		char *hphone;
+		char *wphone;
+		char *mphone;
+		int dbid;
+	};
+
+	struct yahoo_buddy {
+		char *group;
+		char *id;
+		char *real_name;
+		struct yab *yab_entry;
+	};
+
+	enum yahoo_search_type {
+		YAHOO_SEARCH_KEYWORD = 0,
+		YAHOO_SEARCH_YID,
+		YAHOO_SEARCH_NAME
+	};
+
+	enum yahoo_search_gender {
+		YAHOO_GENDER_NONE = 0,
+		YAHOO_GENDER_MALE,
+		YAHOO_GENDER_FEMALE
+	};
+
+	enum yahoo_search_agerange {
+		YAHOO_AGERANGE_NONE = 0
+	};
+
+	struct yahoo_found_contact {
+		char *id;
+		char *gender;
+		char *location;
+		int age;
+		int online;
+	};
 
 /*
  * Function pointer to be passed to http get/post and send file
  */
-typedef void (*yahoo_get_fd_callback)(int id, int fd, int error, void *data);
+	typedef void (*yahoo_get_fd_callback) (int id, void *fd, int error,
+		void *data);
 
 /*
  * Function pointer to be passed to yahoo_get_url_handle
  */
-typedef void (*yahoo_get_url_handle_callback)(int id, int fd, int error,
-		const char *filename, unsigned long size, void *data);
-
-
-struct yahoo_chat_member {
-	char *id;
-	int  age;
-	int  attribs;
-	char *alias;
-	char *location;
-};
-
-struct yahoo_process_status_entry {
-	char *name;	/* 7      name */
-	int state;	/* 10     state */
-	int flags;	/* 13     flags, bit 0 = pager, bit 1 = chat, bit 2 = game */
-	int mobile;	/* 60     mobile */
-	char *msg;	/* 19     custom status message */
-	int away;	/* 47     away (or invisible) */
-	int buddy_session; /* 11  state */
-	int f17;	/* 17     in chat? then what about flags? */
-	int idle;	/* 137    seconds idle */
-	int f138;	/* 138    state */
-	char *f184;	/* 184    state */
-	int f192;	/* 192    state */
-	int f10001;	/* 10001  state */
-	int f10002;	/* 10002  state */
-	int f198;	/* 198    state */
-	char *f197;	/* 197    state */
-	char *f205;	/* 205    state */
-	int f213;	/* 213    state */
-};
+	typedef void (*yahoo_get_url_handle_callback) (int id, void *fd,
+		int error, const char *filename, unsigned long size,
+		void *data);
+
+	struct yahoo_chat_member {
+		char *id;
+		int age;
+		int attribs;
+		char *alias;
+		char *location;
+	};
+
+	struct yahoo_process_status_entry { 
+		char *name;     /* 7      name */ 
+		int state;      /* 10     state */ 
+		int flags;      /* 13     flags, bit 0 = pager, bit 1 = chat, bit 2 = game */ 
+		int mobile;     /* 60     mobile */ 
+		char *msg;      /* 19     custom status message */ 
+		int away;       /* 47     away (or invisible) */ 
+		int buddy_session; /* 11  state */ 
+		int f17;        /* 17     in chat? then what about flags? */ 
+		int idle;       /* 137    seconds idle */ 
+		int f138;       /* 138    state */ 
+		char *f184;     /* 184    state */ 
+		int f192;       /* 192    state */ 
+		int f10001;     /* 10001  state */ 
+		int f10002;     /* 10002  state */ 
+		int f198;       /* 198    state */ 
+		char *f197;     /* 197    state */ 
+		char *f205;     /* 205    state */ 
+		int f213;       /* 213    state */ 
+	};
 
 #ifdef __cplusplus
 }
 #endif
-
 #endif
